//THIS FILE IS AUTOGENERATED
//DO NOT MODIFY
import { Model } from 'mongoose';
import { Report, ReportDocument } from '../Report';
import { ReportService } from '../ReportService';
import { BaseController } from '@core/api/BaseController';
import { MEDICALPRACTICE_PERMISSIONS } from '@modules/medicalpractice/permissions';
import { Get, Post, Patch, Delete, QueryParams, UseBefore, Res, Body, Param, Session, Header } from 'routing-controllers';
import { authenticated, checkPermission, checkApiDisabled, checkResourceDisabled } from '@core/api/middleware';
import { ModelController } from '@core/api/decorators';

@ModelController('Report')
@UseBefore(checkApiDisabled(ReportBaseController))
export class ReportBaseController extends BaseController {
    protected model: Model<ReportDocument>;

    protected static readonly _objName: string = 'Report';
    protected static readonly _apiDisabled: boolean = false;
    protected static readonly _readable: boolean = true;
    protected static readonly _creatable: boolean = true;
    protected static readonly _updatable: boolean = true;
    protected static readonly _deletable: boolean = true;
    protected static readonly _permission = {
        read: MEDICALPRACTICE_PERMISSIONS.REPORT.READ,
        create: MEDICALPRACTICE_PERMISSIONS.REPORT.CREATE,
        update: MEDICALPRACTICE_PERMISSIONS.REPORT.UPDATE,
        delete: MEDICALPRACTICE_PERMISSIONS.REPORT.DELETE,
    };
    protected static readonly _auth = {
        read: true,
        create: true,
        update: true,
        delete: true,
    };

    constructor(reportService: ReportService) {
        super(Report, reportService);
    }

    @Get('/')
    @UseBefore(checkResourceDisabled(ReportBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.REPORT.READ))
    @UseBefore(authenticated)
    public async getAllReport(@QueryParams() params) {
        return super.getAll(params);
    }

    @Get('/:id')
    @UseBefore(checkResourceDisabled(ReportBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.REPORT.READ))
    @UseBefore(authenticated)
    public async getOneReport(@Param('id') id: string, @QueryParams() params) {
        return await super.getOne(id, params);
    }

    @Post('/')
    @UseBefore(checkResourceDisabled(ReportBaseController.creatable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.REPORT.READ))
    @UseBefore(authenticated)
    public async postReport(@Session() session, @Body() body: any) {
        return super.post(body, session);
    }

    @Patch('/:id')
    @UseBefore(checkResourceDisabled(ReportBaseController.updatable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.REPORT.READ))
    @UseBefore(authenticated)
    public async patchReport(@Session() session, @Param('id') id: string, @QueryParams() params, @Body() body: any) {
        return super.patch(id, body, session, params);
    }

    @Delete('/:id')
    @UseBefore(checkResourceDisabled(ReportBaseController.deletable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.REPORT.READ))
    @UseBefore(authenticated)
    public async deleteReport(@Session() session, @Param('id') id: string) {
        return super.delete(session, id);
    }

    @Get('/meta/options')
    @UseBefore(authenticated)
    public async getMetaOptionsReport(@QueryParams() query) {
        return await super.getMetaOptions(query);
    }

    @Get('/export/csv')
    @Header('Content-Type', 'text/csv')
    @UseBefore(checkResourceDisabled(ReportBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.REPORT.READ))
    @UseBefore(authenticated)
    public async getCsvExportReport(@Res() response, @QueryParams() query) {
        response.attachment(`${ReportBaseController._objName.toLowerCase()}.csv`);
        const data = await super.getExport('csv', query);
        return response.send(data);
    }

    @Get('/export/xlsx')
    @Header('Content-Type', 'application/vnd.ms-excel')
    @UseBefore(checkResourceDisabled(ReportBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.REPORT.READ))
    @UseBefore(authenticated)
    public async getXlsxExportReport(@Res() response, @QueryParams() query) {
        response.attachment(`${ReportBaseController._objName.toLowerCase()}.xlsx`);
        const data = await super.getExport('xlsx', query);
        return response.send(data);
    }

    @Get('/export/pdf')
    @Header('Content-Type', 'application/pdf')
    @UseBefore(checkResourceDisabled(ReportBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.REPORT.READ))
    @UseBefore(authenticated)
    public async getPdfExportReport(@Res() response, @QueryParams() query) {
        response.attachment(`${ReportBaseController._objName.toLowerCase()}.pdf`);
        const data = await super.getExport('pdf', query);
        return response.send(data);
    }
}
